//	LCD print Cu
//	WinAVR-20080610	-Os
//	2009/09/04	ver1.00

#include	<avr/io.h>
#include	<util/delay.h>
#include	<string.h>		//strlen()
#include	"printlib.h"

//----------------------------------------
//[U[Cӂŏ
//LȒl	4800, 9600, 19200, 38400
//----------------------------------------
#define LCD_PRINT_BAUD_RATE		4800
//----------------------------------------

void	printlibLcdPrintInit()
{
	//VAʐM
	//UMSEL=0:񓯊, UPM1/0=00:peBȂ, USBS=0:Xgbvrbg1, UCSRB:UCSZ2-UCSRC:UCSZ1/0=011:f[^8rbg
	UBRRH	= 0;
	UBRRL	= F_CPU / LCD_PRINT_BAUD_RATE / 16 - 1;
	UCSRB	= (1 << TXEN) | (0 << UCSZ2);	//TXD(PD1)Lɂ
	UCSRC	= (0 << UMSEL) | (0 << UPM1) | (0 << UPM0) | (0 << USBS) | (1 << UCSZ1) | (1 << UCSZ0);
}

static	void	sendByte(uint8_t n)
{
	loop_until_bit_is_set(UCSRA, UDRE);		//Mobt@̋󂫑҂
	UDR = n;
}

void	printlibLcdPrintCls()
{
	sendByte(LCD_PRINT_CMD_CLS);
	_delay_ms(5);	//LCDW[ClearDisplayR}h͊ɎԂ̂Ŏԑ҂Kv
}

/*
void	printlibLcdPrintSetPos(uint8_t x)
{
	sendByte(LCD_PRINT_CMD_SET_POS);
	sendByte(x);	//x = 0-7, 0x40 + 0-7
}
*/

void	printlibLcdPrint1(uint8_t type, uint8_t data)
{
	sendByte(type);
	sendByte(data);
}

void	printlibLcdPrint2(uint8_t type, uint16_t data)
{
	sendByte(type);
	sendByte(data & 0xFF);
	sendByte((data >> 8) & 0xFF);
}

void	printlibLcdPrintS(char* s)
{
	sendByte(LCD_PRINT_DATA_TYPE_STR | strlen(s));	//0<=strlen(s)<=8 ł邱
	while (*s != 0)
		sendByte(*s++);
}
